#include <iostream>
#include <list>
#include <algorithm>
using namespace std;

void printListen (const list<int>& l1, const list<int>& l2)
{
    cout << "liste1: ";
    copy (l1.begin(), l1.end(), ostream_iterator<int>(cout," "));
    cout << endl << "liste2: ";
    copy (l2.begin(), l2.end(), ostream_iterator<int>(cout," "));
    cout << endl << endl;
}

int main()
{
    // zwei leere Integer-Listen anlegen
    list<int> liste1, liste2;

    // Listen mit Elementen fuellen
    for (int i=0; i<6; i++) {
        liste1.push_back (i);
        liste2.push_front (i);
    }
    printListen (liste1, liste2);

    // Elemente der ersten Liste in die zweite vor 3 einhaengen
    liste2.splice (find(liste2.begin(),liste2.end(),3),
                   liste1);
    printListen (liste1, liste2);

    // erstes Element an das Ende verschieben
    liste2.splice (liste2.end(),        // Ziel-Position
                   liste2,              // Quell-Liste
                   liste2.begin());     // Quell-Position
    printListen (liste1, liste2);

    // zweite Liste sortieren, erster zuweisen
    // und Duplikate entfernen
    liste2.sort();
    liste1 = liste2;
    liste2.unique();
    printListen (liste1, liste2);

    // zweite Liste sortiert in der ersten aufnehmen
    liste1.merge (liste2);
    printListen (liste1, liste2);
}
