template <class charT, class traits>
basic_istream<charT,traits>&
operator >> (basic_istream<charT,traits>& strm, Bruch& b)
{
    int z, n;

    /* Zaehler einlesen
     */
    strm >> z;

    /* falls vorhanden, '/' und Nenner einlesen
     */
    if (strm.peek() == '/') {
        strm.get();
        strm >> n;
    }
    else {
        n = 1;
    }

    /* Nenner == 0 ?
     */
    if (n == 0) {
        // Fail-Status setzen
        strm.setstate (ios::failbit);
        return strm;
    }

    /* falls Stream in Ordnung
     *  dann Wert zuweisen
     */
    if (strm) {
        b = Bruch(z,n);
    }

    return strm;
}
