int liesUndBerechneSumme (istream& strm)
{
    ios::iostate oldExceptions;
    int wert, summe;

    /* Failbit und Badbit fuehren beim Einlesen zu Exceptions
     *  - BEACHTE: auch EOF setzt das Failbit
     */
    oldExceptions = strm.exceptions();
    strm.exceptions (ios::eofbit | ios::failbit | ios::badbit);

    cerr << "exceptions(): " << strm.exceptions() << endl;
    cerr << "ios::eofbit: " << ios::eofbit << endl;
    cerr << "ios::failbit: " << ios::failbit << endl;
    cerr << "ios::badbit: " << ios::badbit << endl;

    try {
        /* solange nicht EOF,
         * Wert lesen und aufsummieren
         */
        summe = 0;
        while (strm >> wert) {
            summe += wert;
        }
    }
    catch (...) {
        /* falls nicht Fehler wegen EOF
         *  - Exception hochreichen
         */
        if (!strm.eof()) {
            // alte Exceptions restaurieren
            strm.exceptions (oldExceptions);
            throw;    // rethrow
        }
    }

    // alte Exceptions restaurieren
    strm.exceptions (oldExceptions);

    /* Summe zurueckliefern
     */
    return summe;
}
