#include <iostream>
#include <set>
#include <algorithm>
using namespace std;

#include "assoiter.h"

int main()
{
    // Beispiel-Container
    set<int> menge;   

    /* Asso-Insert-Iterator fuer menge erzeugen
     */
    asso_insert_iterator<set<int> > iter(menge);

    /* Elemente damit einfuegen
     */
    iter = 1;
    iter = 2;
    iter = 3;

    /* Elemente ausgeben
     */
    copy (menge.begin(), menge.end(),        // Quellbereich
          ostream_iterator<int>(cout," "));  // Zielbereich
    cout << endl;

    /* Asso-Insert-Iterator als Asso-Inserter erzeugen
     */
    asso_inserter(menge) = 55;

    /* Elemente ausgeben
     */
    copy (menge.begin(), menge.end(),        // Quellbereich
          ostream_iterator<int>(cout," "));  // Zielbereich
    cout << endl;

    /* copy() mit Asso-Inserter zum Einfuegen
     */
    static int werte [] = { 33, 67, -4, 13, 5, 2 };

    copy (werte, werte+(sizeof(werte)/sizeof(werte[0])),  // Quelle
          asso_inserter(menge));                          // Ziel

    /* Elemente ausgeben
     */
    copy (menge.begin(), menge.end(),        // Quellbereich
          ostream_iterator<int>(cout," "));  // Zielbereich
    cout << endl;
}
